]> git.donarmstrong.com Git - deb_pkgs/autorandr.git/blob - autorandr
Added a virtual profile named 'common', which calculates the lowest common resolution...
[deb_pkgs/autorandr.git] / autorandr
1 #!/bin/sh
2 #
3 # Automatically select a display configuration based on connected devices
4 #
5 # Stefan Tomanek <stefan.tomanek@wertarbyte.de>
6 #
7 # How to use:
8 #
9 # Save your current display configuration and setup with:
10 #  $ autorandr --save mobile
11 #
12 # Connect an additional display, configure your setup and save it:
13 #  $ autorandr --save docked
14 #
15 # Now autorandr can detect which hardware setup is active:
16 #  $ autorandr
17 #    mobile
18 #    docked (detected)
19 #
20 # To automatically reload your setup, just append --change to the command line
21 #
22 # To manually load a profile, you can use the --load <profile> option.
23 #
24 # autorandr tries to avoid reloading an identical configuration. To force the
25 # (re)configuration, apply --force.
26 #
27 # To prevent a profile from being loaded, place a script call "block" in its
28 # directory. The script is evaluated before the screen setup is inspected, and
29 # in case of it returning a value of 0 the profile is skipped. This can be used
30 # to query the status of a docking station you are about to leave.
31 #
32 # If no suitable profile can be identified, the current configuration is kept.
33 # To change this behaviour and switch to a fallback configuration, specify
34 # --default <profile>
35 #
36 # Another script called "postswitch "can be placed in the directory
37 # ~/.autorandr as well as in all profile directories: The scripts are executed
38 # after a mode switch has taken place and can notify window managers or other
39 # applications about it.
40 #
41 #
42 # While the script uses xrandr by default, calling it by the name "autodisper"
43 # or "auto-disper" forces it to use the "disper" utility, which is useful for
44 # controlling nvidia chipsets. The formats for fingerprinting the current setup
45 # and saving/loading the current configuration are adjusted accordingly.
46
47 XRANDR=/usr/bin/xrandr
48 DISPER=/usr/bin/disper
49 XDPYINFO=/usr/bin/xdpyinfo
50 PROFILES=~/.autorandr/
51 CONFIG=~/.autorandr.conf
52
53 CHANGE_PROFILE=0
54 FORCE_LOAD=0
55 DEFAULT_PROFILE=""
56 SAVE_PROFILE=""
57
58 FP_METHODS="setup_fp_sysfs_edid setup_fp_xrandr_edid"
59 CURRENT_CFG_METHOD="current_cfg_xrandr"
60 LOAD_METHOD="load_cfg_xrandr"
61
62 SCRIPTNAME="$(basename $0)"
63 # when called as autodisper/auto-disper, we assume different defaults
64 if [ "$SCRIPTNAME" = "auto-disper" ] || [ "$SCRIPTNAME" = "autodisper" ]; then
65         echo "Assuming disper defaults..." >&2
66         FP_METHODS="setup_fp_disper"
67         CURRENT_CFG_METHOD="current_cfg_disper"
68         LOAD_METHOD="load_cfg_disper"
69 fi
70
71 if [ -f $CONFIG ]; then
72         echo "Loading configuration from '$CONFIG'" >&2
73         . $CONFIG
74 fi
75
76 setup_fp_xrandr_edid() {
77         $XRANDR -q --verbose | awk '
78         /^[^ ]+ (dis)?connected / { DEV=$1; }
79         $1 ~ /^[a-f0-9]+$/ { ID[DEV] = ID[DEV] $1 }
80         END { for (X in ID) { print X " " ID[X]; } }'
81 }
82
83 setup_fp_sysfs_edid() {
84         # xrandr triggers the reloading of EDID data
85         $XRANDR -q > /dev/null
86         # hash the EDIDs of all _connected_ devices
87         for P in /sys/class/drm/card*-*/; do
88                 # nothing found
89                 [ ! -d "$P" ] && continue
90                 if grep -q "^connected$" < "${P}status"; then
91                         echo -n "$(basename "$P") "
92                         md5sum ${P}edid | awk '{print $1}'
93                 fi
94         done
95 }
96
97 setup_fp_disper() {
98         $DISPER -l | grep '^display '
99 }
100
101 setup_fp() {
102         local FP="";
103         for M in $FP_METHODS; do
104                 FP="$($M)"
105                 if [ -n "$FP" ]; then
106                         break
107                 fi
108         done
109         if [ -z "$FP" ]; then
110                 echo "Unable to fingerprint display configuration" >&2
111                 return
112         fi
113         echo "$FP"
114 }
115
116 current_cfg_xrandr() {
117         local PRIMARY_SETUP="";
118         if [ -x "$XDPYINFO" ]; then
119                 PRIMARY_SETUP="$($XDPYINFO -ext XINERAMA | awk '/^  head #0:/ {printf $3 $5}')"
120         fi
121         $XRANDR -q | awk -v primary_setup="${PRIMARY_SETUP}" '
122         # display is connected and has a mode
123         /^[^ ]+ connected [^(]/ {
124                 print "output "$1;
125                 if ($3 == "primary") {
126                         print $3
127                         split($4, A, "+")
128                         $4=$5
129                 }
130                 else {
131                         split($3, A, "+");
132                         if (A[1] A[2] "," A[3] == primary_setup)
133                                 print "primary";
134                 }
135                 if (($4 == "left") || ($4 == "right")) {
136                         split(A[1], B, "x");
137                         A[1] = B[2]"x"B[1];
138                 }
139                 print "mode "A[1];
140                 print "pos "A[2]"x"A[3];
141                 if ($4 !~ /^\(/) {
142                         print "rotate "$4;
143                 }
144                 else {
145                         print "rotate normal";
146                 }
147                 next;
148         }
149         # disconnected or disabled displays
150         /^[^ ]+ (dis)?connected / ||
151         /^[^ ]+ unknown connection / {
152                 print "output "$1;
153                 print "off";
154                 next;
155         }'
156 }
157
158 current_cfg_disper() {
159         $DISPER -p
160 }
161
162 common_cfg_xrandr() {
163         $XRANDR -q | awk '
164         # variables:
165         #   output: current output
166         #   outputlist: space sep list of all outputs
167         #   outputarr: array of all connected outputs
168         #   outputarrsize: number of connected outputs
169         #   modelist[800x600]: space sep list of outputs supporting mode
170         BEGIN {
171             ORS = " " # output space sep argument list for xrandr
172         }
173         # display is connected
174         /^[^ ]+ connected / {
175             output=$1;
176             outputlist=outputlist " " output
177             outputarr[outputarrsize++]=output
178         }
179         # disconnected or disabled displays
180         /^[^ ]+ disconnected / ||
181         /^[^ ]+ unknown connection / {
182             print "--output",$1,"--off";
183         }
184         # modes available on a screen
185         /^   [0-9]+x[0-9]+/ {
186             modelist[$1]=modelist[$1] " " output
187         }
188         END {
189             # find common mode with largest screen area
190             for (m in modelist) {
191                 if (modelist[m] == outputlist) {
192                     # calculate area of resolution
193                     split(m, wh, "x");
194                     if (wh[1]*wh[2] >= maxdim) {
195                         maxdim=wh[1]*wh[2]
196                         maxmode=m
197                     }
198                 }
199             }
200             if (maxmode) {
201                 for (i in outputarr)
202                     print "--output",outputarr[i],"--mode",maxmode,"--pos","0x0"
203             }
204             print param
205         }' \
206                 | xargs -L 1 $XRANDR
207 }
208
209 current_cfg() {
210         $CURRENT_CFG_METHOD;
211 }
212
213 blocked() {
214         local PROFILE="$1"
215         [ ! -x "$PROFILES/$PROFILE/block" ] && return 1
216
217         "$PROFILES/$PROFILE/block" "$PROFILE"
218 }
219
220 config_equal() {
221         local PROFILE="$1"
222         if [ "$(cat "$PROFILES/$PROFILE/config")" = "$(current_cfg)" ]; then
223                 echo "Config already loaded"
224                 return 0
225         else
226                 return 1
227         fi
228 }
229
230 load_cfg_xrandr() {
231         # sed 1: Prefix arguments with "--"
232         # sed 2: Merge arguments into one line per output
233         # sed 3: Merge into two lines, all --off outputs in the first one
234         sed 's/^/--/' "$1" | sed -e '
235                 :START
236                 /\n--output/{P;D}
237                 s/\n/ /
238                 N;bSTART' | sed -e '
239                         ### First line
240                         / --off/{
241                                 G
242                                 # Merge if next line contains --off
243                                 s/\n\([^\n]* --off\)/ \1/
244                                 h
245                                 $!d;b
246                         }
247                         ### Last line
248                         H;x
249                         # Merge if previous line contains --mode
250                         s/\(--mode [^\n]*\)\n/\1 /
251                         h
252                         $!d' | xargs -L 1 $XRANDR
253 }
254
255 load_cfg_disper() {
256         $DISPER -i < "$1"
257 }
258
259 load() {
260         local PROFILE="$1"
261         local CONF="$PROFILES/$PROFILE/config"
262         [ -f "$CONF" -o "$PROFILE" = "common" ] || return 1
263         if [ -x "$PROFILES/preswitch" ]; then
264                 "$PROFILES/preswitch" "$PROFILE"
265         fi
266         if [ -x "$PROFILES/$PROFILE/preswitch" ]; then
267                 "$PROFILES/$PROFILE/preswitch" "$PROFILE"
268         fi
269
270         if [ $PROFILE = "common" ]; then
271                 echo " -> setting largest common mode"
272                 common_cfg_xrandr
273         else
274                 echo " -> loading profile $PROFILE"
275                 $LOAD_METHOD "$CONF"
276         fi
277
278         if [ -x "$PROFILES/$PROFILE/postswitch" ]; then
279                 "$PROFILES/$PROFILE/postswitch" "$PROFILE"
280         fi
281         if [ -x "$PROFILES/postswitch" ]; then
282                 "$PROFILES/postswitch" "$PROFILE"
283         fi
284 }
285
286 help() {
287         cat <<EOH
288 Usage: $SCRIPTNAME [options]
289
290 -h, --help              get this small help
291 -c, --change            reload current setup
292 -s, --save <profile>    save your current setup to profile <profile>
293 -l, --load <profile>    load profile <profile>
294 -d, --default <profile> make profile <profile> the default profile
295 --force                 force (re)loading of a profile
296 --fingerprint           fingerprint your current hardware setup
297 --config                dump your current xrandr setup
298
299  To prevent a profile from being loaded, place a script call "block" in its
300  directory. The script is evaluated before the screen setup is inspected, and
301  in case of it returning a value of 0 the profile is skipped. This can be used
302  to query the status of a docking station you are about to leave.
303
304  If no suitable profile can be identified, the current configuration is kept.
305  To change this behaviour and switch to a fallback configuration, specify
306  --default <profile>.
307
308  Another script called "postswitch "can be placed in the directory
309  ~/.autorandr as well as in any profile directories: The scripts are executed
310  after a mode switch has taken place and can notify window managers.
311
312  When called by the name "autodisper" or "auto-disper", the script uses "disper"
313  instead of "xrandr" to detect, configure and save the display configuration.
314
315 EOH
316         exit
317 }
318 # process parameters
319 OPTS=$(getopt -n autorandr -o s:l:d:cfh --long change,default:,save:,load:,force,fingerprint,config,help -- "$@")
320 if [ $? != 0 ] ; then echo "Terminating..." >&2 ; exit 1 ; fi
321 eval set -- "$OPTS"
322
323 while true; do
324         case "$1" in
325                 -c|--change) CHANGE_PROFILE=1; shift ;;
326                 -d|--default) DEFAULT_PROFILE="$2"; shift 2 ;;
327                 -s|--save) SAVE_PROFILE="$2"; shift 2 ;;
328                 -l|--load) LOAD_PROFILE="$2"; shift 2 ;;
329                 -h|--help) help ;;
330                 --force) FORCE_LOAD=1; shift ;;
331                 --fingerprint) setup_fp; exit 0;;
332                 --config) current_cfg; exit 0;;
333                 --) shift; break ;;
334                 *) echo "Error: $1"; exit 1;;
335         esac
336 done
337
338 CURRENT_SETUP="$(setup_fp)"
339
340 if [ -n "$SAVE_PROFILE" ]; then
341         echo "Saving current configuration as profile '${SAVE_PROFILE}'"
342         mkdir -p "$PROFILES/$SAVE_PROFILE"
343         echo "$CURRENT_SETUP" > "$PROFILES/$SAVE_PROFILE/setup"
344         $CURRENT_CFG_METHOD > "$PROFILES/$SAVE_PROFILE/config"
345         exit 0
346 fi
347
348 if [ -n "$LOAD_PROFILE" ]; then
349         CHANGE_PROFILE=1 FORCE_LOAD=1 load "$LOAD_PROFILE"
350         exit $?
351 fi
352
353 for SETUP_FILE in $PROFILES/*/setup; do
354         if ! [ -e $SETUP_FILE ]; then
355                 break
356         fi
357         PROFILE="$(basename $(dirname "$SETUP_FILE"))"
358         echo -n "$PROFILE"
359
360         if blocked "$PROFILE"; then
361                 echo " (blocked)"
362                 continue
363         fi
364
365         FILE_SETUP="$(cat "$PROFILES/$PROFILE/setup")"
366         if [ "$CURRENT_SETUP" = "$FILE_SETUP" ]; then
367                 echo " (detected)"
368                 if [ "$CHANGE_PROFILE" -eq 1 ]; then
369                         if [ "$FORCE_LOAD" -eq 1 ] || ! config_equal "$PROFILE"; then
370                                 load "$PROFILE"
371                         fi
372                 fi
373                 # found the profile, exit with success
374                 exit 0
375         else
376                 echo ""
377         fi
378 done
379
380 # we did not find the profile, load default
381 if [ -n "$DEFAULT_PROFILE" ]; then
382         echo "No suitable profile detected, falling back to $DEFAULT_PROFILE"
383         load "$DEFAULT_PROFILE"
384 fi
385 exit 1
386
387 # Local Variables:
388 # tab-width: 8
389 # sh-basic-offset: 8
390 # sh-indentation: 8
391 # indent-tabs-mode: t
392 # End: